Menu = Core.class(Sprite)

function Menu:init()
	-- THEME
	local colortheme = g_colortheme02
	-- BG
	application:setBackgroundColor(colortheme[3])
	local mybgbmp = Bitmap.new(Texture.new("gfx/menu/menu_bg.png"))
	mybgbmp:setAnchorPoint(0.5, 0.5)
	mybgbmp:setScale(0.8)
	mybgbmp:setPosition(myappwidth / 2, myappheight / 2)
	self:addChild(mybgbmp)
	-- TITLE
	local myfont = TTFont.new(g_font1, 44, "")
	local mytitle = TextField.new(myfont, "MY GAME\n   TITLE")
	mytitle:setAnchorPoint(0.5, 0.5)
	mytitle:setPosition(myappwidth / 2, 2.75 * myappheight / 10)
	mytitle:setTextColor(colortheme[4])
	mytitle:setRotation(-5)
	self:addChild(mytitle)
	-- BUTTON THEME
	local mypixelcolorup = colortheme[4]
	local mypixelcolordown = colortheme[5]
	local mytextcolorup = colortheme[5]
	local mytextcolordown = colortheme[6]
	local mytextcolordisabled = colortheme[7]
	-- BUTTON 1
	local mybtn01 = ButtonTextUDDP.new({
		pixelcolorup=mypixelcolorup,
		text="    BUTTON 1    ", font=g_font1, fontsize=32, textcolorup=mytextcolorup, textcolordown=mytextcolordown,
	})
	mybtn01:setPosition(myappwidth / 2, 4.5 * myappheight / 10)
	self:addChild(mybtn01)
	mybtn01:addEventListener("clicked", function()
		scenemanager:changeScene("level1", 1) -- scenemanager:changeScene("level1", 1, SceneManager.moveFromRight, easing.outBack)
	end)
	-- BUTTON 2
	local mybtn02 = ButtonTextUDDP.new({
		pixelcolorup=mypixelcolorup, pixelcolordown=mypixelcolordown,
		text=" BUTTON TWO ", font=g_font1, fontsize=32, textcolorup=mytextcolorup, textcolordown=mytextcolordown,
	})
	mybtn02:setPosition(myappwidth / 2, 5.5 * myappheight / 10)
	self:addChild(mybtn02)
	mybtn02:addEventListener("clicked", function() scenemanager:changeScene("level1", 1) end)
	-- BUTTON 3
	local mybtn03 = ButtonTextUDDP.new({
		text="    BUTTON 3    ", font=g_font1, fontsize=32, textcolorup=mytextcolorup, textcolordown=mytextcolordown,
	})
	mybtn03:setPosition(myappwidth / 2, 6.5 * myappheight / 10)
	self:addChild(mybtn03)
	mybtn03:addEventListener("clicked", function() scenemanager:changeScene("level1", 1) end)
	-- BUTTON 4
	local mybtn04 = ButtonTextUDDP.new({
		imgup="gfx/ui/btn_01_up.png", imgdown="gfx/ui/btn_01_down.png",
		text="BUTTON FOUR", font=g_font1, fontsize=28, textcolorup=mytextcolorup, textcolordown=mytextcolordown,
		defaultpadding=24,
	})
	mybtn04:setPosition(myappwidth / 2, 7.5 * myappheight / 10)
	self:addChild(mybtn04)
	mybtn04:addEventListener("clicked", function() scenemanager:changeScene("level1", 1) end)
	-- BUTTON QUIT
	local mybtn03 = ButtonTextUDDP.new({
		imgup="gfx/ui/btn_01_up.png", imgdown="gfx/ui/btn_01_down.png",imgdisabled="gfx/ui/btn_01_disabled.png",
		text="QUIT", font=g_font1, fontsize=32, textcolorup=mytextcolorup, textcolordown=mytextcolordown,
	})
	mybtn03:setPosition(myappwidth / 2, myappheight - mybtn03:getHeight() / 2 - 8)
	self:addChild(mybtn03)
	mybtn03:addEventListener("clicked", function()
--		application:exit()
	end)
	mybtn03:setDisabled(true)
	-- LISTENERS
	self:addEventListener("enterBegin", self.onTransitionInBegin, self)
	self:addEventListener("enterEnd", self.onTransitionInEnd, self)
	self:addEventListener("exitBegin", self.onTransitionOutBegin, self)
	self:addEventListener("exitEnd", self.onTransitionOutEnd, self)
end

-- GAME LOOP
function Menu:onEnterFrame(e)
end

-- EVENT LISTENERS
function Menu:onTransitionInBegin()
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Menu:onTransitionInEnd()
	self:myKeysPressed()
end

function Menu:onTransitionOutBegin()
	self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Menu:onTransitionOutEnd()
end

-- KEYS HANDLER
function Menu:myKeysPressed()
	self:addEventListener(Event.KEY_UP, function(e)
		if e.keyCode == KeyCode.BACK or e.keyCode == KeyCode.ESC then
			application:exit()
		end
	end)
end
